const bodyValidation=(schema,body)=>{
    schema.array.forEach(element => {
            if(element.required){
                
            }
    });     
}

exports.checkKeyMatch=(arr1, arr2,section="Body")=> {
    // Iterate over each object in arr1
    var errors=[]
    if(arr1){
    for (let obj1 of arr1) {
        if (obj1.required) {
        let key = obj1.itemName.toLowerCase()
      
        if(arr2.hasOwnProperty(obj1.itemName) ||  arr2.hasOwnProperty(key) ){
          
           let value =   arr2[obj1.itemName]? arr2[obj1.itemName]:arr2[key];
           console.log(obj1.value.length)
           console.log(value)
           if( obj1.value.length>0){

                if(obj1.value=="multipart/form-data"){
                    if (!value.includes(obj1.value)) {
                        errors.push(section+" data  not matching: "+obj1.itemName+" , should be "+obj1.value);
                    
                    }
                }else{
                if (obj1.value != value) {
                    errors.push(section+" data  not matching: "+obj1.itemName+" , should be "+obj1.value);
                
                }
            } 
            }else{
                if(obj1.validation=="Email" && !validateEmail(value)){
                    errors.push(section+" data["+obj1.itemName+"]  not valid :"+value+"  , should be valid email");
                }else if(obj1.validation=="Number" && !validateNumber(value)){
                    errors.push(section+" data["+obj1.itemName+"]  not valid :"+value+"  , should be valid Number");
                }else if(obj1.validation=="Integer" && !validateInteger(value)){
                    errors.push(section+" data["+obj1.itemName+"]  not valid :"+value+"  , should be valid Integer");
                }else if(obj1.validation=="Date" && !validateDate(value)){
                    errors.push(section+" data["+obj1.itemName+"]  not valid :"+value+"  , should be valid Date");
                }else if(obj1.validation=="String-Required" && value.length==0){
                    errors.push(section+" data["+obj1.itemName+"]  not valid :"+value+"  , should be valid String");
                }
            }
        }else{
            errors.push(section+" data  not available: "+obj1.itemName);
        }
    }
   
}
    }
return errors; //
}

exports.checkFileMatch=(validFileTypes,file)=> {
    // Iterate over each object in arr1
    var errors=[]
   
    console.log(validFileTypes)
    console.log(file)
    if(!isValidFileType(validFileTypes,file)){
        errors.push("File type not valid  supports "+validFileTypes.join(","))
    }   
return errors; //
}




function validateEmail(email) {
    const emailRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
    return emailRegex.test(email);
}

function validateUsername(username) {
    // Username can contain letters, numbers, underscores, and dots
    const usernameRegex = /^[a-zA-Z0-9_.-]{4,}$/;
    return usernameRegex.test(username);
}

function validateNumber(number) {
    return !isNaN(number);
}

function validateInteger(integer) {
    return Number.isInteger(Number(integer));
}

function validateDate(date) {
    console.log(!isNaN(Date.parse(date)))
    return !isNaN(Date.parse(date));
}

function validateString(string, minLength, maxLength) {
    return typeof string === 'string' && string.length >= minLength && string.length <= maxLength;
}

function validateURL(url) {
    const urlRegex = /^(http|https):\/\/[^ "]+$/;
    return urlRegex.test(url);
}





function isValidFileType(fileTypes, file) {
    const allowedTypes = {
        "XML":"application/xml",
        "JSON":"application/json",
        "GIF":"image/gif",
        "PNG":"image/png",
        "JPG":"image/jpeg",
        "PDF":"application/pdf",
        "DOC":"application/doc",
    }
    const validMimetypes = fileTypes.map(type => allowedTypes[type]);
    
    // Check if the file's mimetype is in the validMimetypes array
    return validMimetypes.includes(file.mimetype);
}

exports.getValueAtPath=(json, path,returnValues=[]) =>{
    const keys = path.split('.').filter(part => part !== ''); 
    let value = json;
    
    //console.log(path)
    for (const key of keys) {
        const parts = key.split('[]');

        if (parts.length == 2) {
            if (value.hasOwnProperty(parts[0])) {
                if (!Array.isArray(value[parts[0]])) {
                    return []; // If value is not an array, return an empty array
                } else {
                     const firstDotIndex = path.indexOf('.') + 1; // Find the index of the first dot and add 1 to 
                     const newPath = path.substring(firstDotIndex); 
                     const arrayValues = value[parts[0]].map(item => this.getValueAtPath(item, newPath,returnValues));
                    return arrayValues;
                }
            } else {
                return [];
            }
        } else if (parts.length == 1) {
            if (!value.hasOwnProperty(key)) {
                return [];
            } else {
                value = value[key];
                returnValues.push(value)
            }
        }
    }

    return value;
}


exports.groupArrayByType=(array,key)=> {
    const typeCounts = {};

    // Count occurrences of each type
    array.forEach(item => {
        const type = item[key];
        if (type) {
            typeCounts[type] = (typeCounts[type] || 0) + 1;
        }
    });

    // Extract unique types
    const uniqueTypes = Object.keys(typeCounts);

    return uniqueTypes;
}
function splitOrString(value) {
    if (value.includes(',')) {
        return value.split(',');
    } else {
        return value;
    }
}

exports.checkPathKeyMatch=(rules, values)=> {
    // Iterate over each object in arr1
    var section="Body"
    var errors=[]
    var compairValues=splitOrString(rules.value);
   if(rules.required ==true && values.length==0){
    errors.push(section+" data["+rules.itemName+"]  not valid   , should be valid String");
   }
   
    for (let value of values) {
        if(Array.isArray(compairValues)){
            if(!value.includes(compairValues)){
                errors.push("Body data  not valid: "+rules.itemName+" , should be in "+compairValues)
            }
        }else{
            //console.log(rules.itemName+" "+rules.validation +"  "+value)
            if(rules.validation=="Email" && !validateEmail(value)){
                errors.push(section+" data["+rules.itemName+"]  not valid :"+value+"  , should be valid email");
            }else if(rules.validation=="Number" && !validateNumber(value)){
                errors.push(section+" data["+rules.itemName+"]  not valid :"+value+"  , should be valid Number");
            }else if(rules.validation=="Integer" && !validateInteger(value)){
                errors.push(section+" data["+rules.itemName+"]  not valid :"+value+"  , should be valid Integer");
            }else if(rules.validation=="Date" && !validateDate(value)){
                errors.push(section+" data["+rules.itemName+"]  not valid :"+value+"  , should be valid Date");
            }else if(rules.validation=="String" && value.length==0 && rules.required==true){
                console.log("*****")
                errors.push(section+" data["+rules.itemName+"]  not valid :"+value+"  , should be valid String");

            }else if(rules.valueLength>0 && value.length<rules.valueLength){
                errors.push(section+" data["+rules.itemName+"]  not valid :"+value+"  , should be valid Minimum "+rules.valueLength+" chars");
            }else if(rules.maxValueLength>0 && value.length>rules.maxValueLength){
                errors.push(section+" data["+rules.itemName+"]  not valid :"+value+"  , should be valid maximum "+rules.maxValueLength+" chars");
            }

        }
    }
    return errors; //
}